<?php
/**
* モジュールを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_ModuleFactory
{
	/*
	 * モジュールを作成
	 */
	public static function create( $module_name )
	{
		log_info( "system",  "モジュール[$module_name]をロードします。", __FILE__, __LINE__ );

		// モジュール設定ファイルの読み込み
		$config = charcoal_ConfigLoader::loadConfig( $module_name, 'module' );

		// クラス名を取得
		$class_name = $config->getString( 'class_name' );

		// モジュールのインスタンス生成
		$module = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIModuleインタフェースを実装しているか確認
		if ( !($module instanceof charcoal_IModule) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IModule" );
		}

		log_info( "system",  "モジュール[$module_name]を初期化します。", __FILE__, __LINE__ );

		// モジュールを初期化
		$module->init( $config );

		log_info( "system",  "モジュール[$module_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたモジュールを返却
		return $module;
	}


}
